#include <hmg.ch>

PROC Main

   DEFINE WINDOW Form_1  ;
		AT                0,0 ;
		WIDTH             910 ;
		HEIGHT            370 ;
		TITLE 'System Inventory' ;
		MAIN ;
      ON INIT SysInvent() 
   END WINDOW
	
Form_1.Center

Form_1.Activate	   

RETU // Main()      

*-------------------------------------------------------------------------------------------
FUNCTION SysInvent()   //  By AndyGlezL
   LOCAL obj, cpu, nInd, obj1, obj2
   
   WaitWindow( "Reading, Please wait...", .T. )
   
   oLocator := win_oleCreateObject( "wbemScripting.SwbemLocator" )
   oWmi     := oLocator:ConnectServer()
   *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   data1:=""
   oCollection:= oWMI:ExecQuery("Select * from Win32_ComputerSystem")
   For Each obj In oCollection
      Name  := 'Computer: '+CHR(9)+obj:Name
      PhysicalMemory := 'PhysicalMemory: '  + CHR(9) + HB_ValToStr( ( VAL( obj:TotalPhysicalMemory) / 1000000 ) / 1024 ) + " GB."
      cNumProcs      := "# of Processors: " + CHR(9) + HB_ValToStr( obj:NumberOfProcessors )
      data1 += Name+CRLF+cNumProcs+CRLF+PhysicalMemory
   Next
   data2:=""
   oCollection := oWMI:ExecQuery("Select * from Win32_OperatingSystem")
   For Each obj In oCollection
      Caption    := 'OS: '           + CHR(9) + obj:Caption + CRLF
      ServPack   := 'Service Pack: ' + CHR(9) + HB_ValToStr( obj:ServicePackMajorVersion ) + CRLF
      cVersion   := "Version:      " + CHR(9) + obj:Version + CRLF 
      FreePhysMem:= 'FreePhysMemory: '+CHR(9) + HB_ValToStr( ( VAL( obj:FreePhysicalMemory ) / 1000 ) / 1024 ) + " GB." + CRLF
      cWinDir    := "Win Directory:" + CHR(9) + obj:WindowsDirectory
      data2 += Caption+ServPack+cVersion+FreePhysMem+cWinDir
   Next
   data3:=""
   oCollection := oWMI:ExecQuery( 'select * from Win32_ComputerSystemProduct' )
   For Each obj In  oCollection
      Vendor := 'Manufacturer: '+CHR(9)+obj:Vendor
      Name   := 'MotherBoard: '+CHR(9)+obj:Name
      IdentifyingNumber := 'Id. Number: '+CHR(9)+obj:IdentifyingNumber
      data3 += Vendor+CRLF+Name+CRLF+IdentifyingNumber
   Next
   data4 := ""
   nInd  := 0
   oCollection := oWMI:ExecQuery("Select * from Win32_DiskDrive")
   For Each obj In oCollection
      nInd++
      Model         := 'Disc Model'+ALLTRIM(HB_ValToStr(nInd))+': '+CHR(9)+obj:Model+CRLF
      *SerialNumber := 'SerialNumber: '+obj:SerialNumber                   // ERROR !   ?????
      InterfaceType := '   Interface'+ALLTRIM(HB_ValToStr(nInd))+': '+CHR(9)+obj:InterfaceType+CRLF
      Size          := '   Disc.Size'+ALLTRIM(HB_ValToStr(nInd))+': '+CHR(9)+HB_ValToStr( ( VAL( obj:Size ) / 1000000 ) / 1024 )+" GB."+CRLF
      Partitions    := '   Partitions'+ALLTRIM(HB_ValToStr(nInd))+': '+CHR(9)+HB_ValToStr( obj:Partitions )+CRLF
      data4 += Model+InterfaceType+Size+Partitions
   Next
   data5 := ""
   oCollection := oWMI:ExecQuery( 'select * from Win32_Processor' )
   For Each cpu In oCollection
      *DeviceID      := 'DeviceID: '+CHR(9)+cpu:DeviceID+CRLF
      *Availability  := 'Availability: '+CHR(9)+HB_ValToStr( cpu:Availability )+CRLF
      AddressWidth  := 'AddressWidth: '+CHR(9)+HB_ValToStr( cpu:AddressWidth )+CRLF
      *CpuStatus     := 'CpuStatus: '+CHR(9)+HB_ValToStr( cpu:CpuStatus )+CRLF
      CurClockSpeed := 'ClockSpeed: '+CHR(9)+HB_ValToStr( cpu:CurrentClockSpeed )+CRLF
      *MaxClockSpeed := 'MaxClockSpeed: '+CHR(9)+HB_ValToStr( cpu:MaxClockSpeed )+CRLF
      L2CacheSize   := 'L2CacheSize: '+CHR(9)+HB_ValToStr( cpu:L2CacheSize )+CRLF
      L2CacheSpeed  := 'L2CacheSpeed: '+CHR(9)+HB_ValToStr( cpu:L2CacheSpeed )+CRLF
      Name          := 'Name: '+ALLTRIM(cpu:Name)
      *data5 += DeviceID+Availability+AddressWidth+CpuStatus+CurClockSpeed+MaxClockSpeed+L2CacheSize+L2CacheSpeed+Name
      data5 += AddressWidth+CurClockSpeed+L2CacheSize+L2CacheSpeed+Name
   Next
   data6 := ""
   nInd  := 0
   aNetConnectStat := { 'Disconnected', 'Connecting', 'Connected', 'Disconnecting', 'Hardware not present', 'Hardware disabled', 'Hardware malfunction', ;
                   'Media disconnected', 'Authenticating', 'Authentication succeeded', 'Authentication failed', 'Invalid address', 'Credentials required' }
   
   oCollection1 := oWMI:ExecQuery( "SELECT * FROM Win32_NetworkAdapter WHERE Manufacturer != 'Microsoft' AND NOT PNPDeviceID LIKE 'ROOT\\%'" )
   oCollection2 := oWMI:ExecQuery( 'SELECT * from Win32_NetworkAdapterConfiguration where IPEnabled=TRUE' )
   For Each obj1 In oCollection1
      nTemp := obj1:NetConnectionStatus
      For Each obj2 In oCollection2
         nInd++
         cDescrip := 'Description'+ALLTRIM(HB_ValToStr(nInd))+': '+CHR(9)+SUBStr( obj2:description, 1, AT( "-", obj2:description ) -2 )+' / '+aNetConnectStat[ nTemp+1 ]+CRLF
         ServiceName := '   ServiceName'+ALLTRIM(HB_ValToStr(nInd))+': '+CHR(9)+obj2:ServiceName(0)+CRLF
         IPAddress   := '   IPAddress'+ALLTRIM(HB_ValToStr(nInd))+': '+CHR(9)+obj2:IPAddress(0)+CRLF
         *DefaultIPGateway := 'DefaultIPGateway: '+obj:DefaultIPGateway(0)       // ERROR !   ????
         MACAddress  := '   MACAddress'+ALLTRIM(HB_ValToStr(nInd))+': '+CHR(9)+obj2:MACAddress(0)
         data6 += cDescrip+ServiceName+IPAddress+MACAddress+CRLF
      Next
   Next
   
   oCollection := 0
   oWMI := 0
   WaitWindow( )
   MsgInfo(data1+CRLF+ ; // REPLICATE( "-", 80 )+CRLF+ ;
         data2+CRLF+REPLICATE( "-", 60 )+CRLF+ ;
         data3+CRLF+REPLICATE( "-", 60 )+CRLF+ ;
         data4+CRLF+REPLICATE( "-", 60 )+CRLF+ ;
         data5+CRLF+REPLICATE( "-", 60 )+CRLF+ ;
         data6, 'System Inventory - By AndyGlezL' )
RETURN nil